"""computes equivalence classes for atoms

GenerateEquivClasses(graph)
"""

def GenerateEquivClasses(graph):
    """(graph) -> given a graph, generate the equivalence classes
    for the nodes and edges of the graph by assigning a unique number
    to uniquely labeled nodes and edges.  The nodes and edges
    must be sortable"""
    
    # sort and rank the Nodes and Edges
    for labeledObject in [graph.nodes(), graph.edges()]:
        # sort the objects based on their label attribute
        labeledObject.sort(lambda x,y: cmp(x.label, y.label))
        last = None
        rank = -1
        for ob in labeledObject:
            if ob.label != last:
                # increment the rank
                rank = rank + 1
            
            ob.equiv_class = rank
            last = ob.label

            
