from Graph import Graph, Node, Edge
import EquivClass
import Canonicalize
import Traverse
import random

# format is label_<nodeid> edgelabel label_<nodeid>
text = """A_1 a B_2
A_1 a C_3
A_4 b B_2
A_1 c B_5
C_3 b B_5"""

def make_graph(edges):
    _nodes = {}
    _edges = {}
    g = Graph()
    
    for e in edges:
        n1, edge, n2 = e.split()
        label1, id1 = n1.split("_")
        label2, id2 = n2.split("_")

        _nodes[id1] = node1 = _nodes.get(id1, Node(label1))
        _nodes[id2] = node2 = _nodes.get(id2, Node(label2))
        edge = Edge(edge)
        g.addNode(node1)
        g.addNode(node2)
        g.addEdge(node1, node2, edge)

    return g

lines = text.split("\n")
import random

last = None
for i in range(1):
    #random.shuffle(lines)
    g = make_graph(lines)
    EquivClass.GenerateEquivClasses(g)
    for node in g.nodes():
        print node.label, node.equiv_class
    print
    Canonicalize.GenerateSymmetryClasses(g)
    print
    for node in g.nodes():
        print node.label, node.symclass
    Traverse.generateSymmetryOrders(g)
    
    nodes = g.nodes()
    nodes.sort(lambda x,y: cmp(x.symorder, y.symorder))
    
    text = "".join(map(str, nodes))

    if last:
        assert last == text
    last = text
