import GraphML
import EquivClass
import Canonicalize
import Traverse
import random, StringIO

nodes = [
    '<node id="n1" label="A"/>',
    '<node id="n2" label="B"/>',
    '<node id="n3" label="C"/>',
    '<node id="n4" label="A"/>',
    '<node id="n5" label="B"/>',
    ]

edges = [
    '<edge source="n1" target="n2" label="a"/>',
    '<edge source="n1" target="n3" label="a"/>',
    '<edge source="n4" target="n2" label="b"/>',
    '<edge source="n1" target="n5" label="c"/>',
    '<edge source="n3" target="n5" label="b"/>',
    ]

def getShuffled():
    """recombine the nodes and edges to scramble the graph"""
    res = ['<graphml>\n <graph edgedefault="undirected">']
    random.shuffle(nodes)
    random.shuffle(edges)
    res.extend(nodes)
    res.extend(edges)
    res.append(" </graph>\n</graphml>")
    return StringIO.StringIO("\n".join(res))

last = None
for i in range(100):
    # read in the sample graph
    g = GraphML.parseGraphML(getShuffled())[0]

    # perform the canonicalization
    EquivClass.GenerateEquivClasses(g)
    Canonicalize.GenerateSymmetryClasses(g)
    Traverse.generateSymmetryOrders(g)

    # get the string representation
    # the string representation of the graph
    # uses the computed symorders to realign the nodes
    # and edges.
    next = str(g)

    if last:
        # are they all the same?
        assert last == next

    last = next



