//......]*[.......]*[.......]*[.......]*[.......]*[.......]*[.......]*[.......].
// ppp.cpp
//......]*[.......]*[.......]*[.......]*[.......]*[.......]*[.......]*[.......].
//
// Example program for choosing best M of N tracking passes.
//
#include <iostream>
#include <fstream>
#include "DpSolution.hpp"
#include "TrackingPass.hpp"
#include "TrackData.hpp"

using namespace std;

//..............................................................................
//       1         2         3         4         5         6         7         8
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//..............................................................................

void main(void)
{
   fstream fout("ppp.txt",ios::out); // output file
   list<DpObject *> passes;          // list of tracking passes
   list<DpObject *> ans;             // answer

   // create the tracking passes
   for(int i = 0; i < trackDataSize; ++i)
   {
      TrackingPass *tp = new TrackingPass(trackData[i].begin,trackData[i].end,
                                          beginPeriod, endPeriod, trackData[i].id);
      passes.push_back(tp);
   }

   // declare a DpSolution
   DpSolution ds(passes, numPasses);

   // print out passes
   fout << "Input List" << endl;
   cout << "Input List" << endl;

   for( list<DpObject *>::const_iterator iter = passes.begin(); iter != passes.end(); ++iter )
   {
      fout << *(*iter) << endl;
      cout << *(*iter) << endl;
      delete *iter;
   }
   fout << endl;
   cout << endl;

   // solve for answer
   ans = ds.solve();

   // print solution
   fout << endl << "Solution" << endl;
   cout << endl << "Solution" << endl;
   fout << ds;
   cout << ds;

   // print results
   fout << endl << "Answer" << endl;
   cout << endl << "Answer" << endl;

   int j = 0;
   for(list<DpObject *>::iterator ater = ans.begin(); ater != ans.end(); ++ater)
   {
       fout << j+1 << " " << *(*ater) << endl;
       cout << j+1 << " " << *(*ater) << endl;
       delete *ater;
       ++j;
   }

}

//......]*[.......]*[.......]*[.......]*[.......]*[.......]*[.......]*[.......].
//      end       end       end       end       end       end       end
//......]*[.......]*[.......]*[.......]*[.......]*[.......]*[.......]*[.......].
